
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>甲骨文 VirtualBox高危堆溢出漏洞（CVE-2017-3332）剖析 / iVAN</title>

    <meta name="description" content="甲骨文 VirtualBox高危堆溢出漏洞（CVE-2017-3332）剖析 本文讲的是 甲骨文 VirtualBox高危堆溢出漏洞(CVE-2017-3332)剖析,1月17日,甲骨文公司发布新一期安全补丁修复公告,修复旗下产品安全漏洞,本次补丁更新中,修复了虚拟化产品Oracle VirtualBox软件的一个高危险漏洞(CVE-2017-3332),并向漏洞发现者360公司 Gear Team团队工程师公开致谢. 公告介绍,Oracle的产品VirtualBox在SVGA显卡模拟中存在堆溢出漏洞,该漏洞能造成拒绝服务和宿主机任意代码执行.在公告中,Oracle对该漏">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">甲骨文 VirtualBox高危堆溢出漏洞（CVE-2017-3332）剖析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本文讲的是<strong> 甲骨文 VirtualBox高危堆溢出漏洞（CVE-2017-3332）剖析，</strong>1月17日，甲骨文公司发布新一期安全补丁修复公告，修复旗下产品安全漏洞，本次补丁更新中，修复了虚拟化产品Oracle  VirtualBox软件的一个高危险漏洞（CVE-2017-3332），并向漏洞发现者360公司 Gear Team团队工程师公开致谢。</p>
<p>公告介绍，Oracle的产品VirtualBox在SVGA显卡模拟中存在堆溢出漏洞，该漏洞能造成拒绝服务和宿主机任意代码执行。在公告中，Oracle对该漏洞危险评分为8.4分，属于风险性较高的漏洞。</p>
<p><a href="https://yqfile.alicdn.com/2269b9f982d2250a211b2002436eb73553ff0e37.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzIyNjliOWY5ODJkMjI1MGEyMTFiMjAwMjQzNmViNzM1NTNmZjBlMzcucG5n.jpg"></a></p>
<p>桌面虚拟化已经越来越成为IT专业人士的重要助手，他们经常在本地机器运行不同操作系统，比如在Mac电脑上运行专为Windows设计的软件。</p>
<p>对于IT专业人士而言，VMware Workstation和Oracle VirtualBox是创建和运行虚拟机的两个主要选择。Oracle VirtualBox广泛用于对Mac OS X、Solaris或32位Windows主机虚拟化，为用户提供实用的用户界面，简化虚拟机的构建、部署和管理。对于大型的虚拟机，VirtualBox的强大处理功能也毫不逊色，因此受到专业人士的青睐。</p>
<p>360Gear Team团队研究员李强发现，VirtualBox在SVGA显卡模拟中存在堆溢出漏洞，该漏洞能造成拒绝服务和宿主机任意代码执行。2016年12月2日，李强将漏洞报告给Oracle安全团队，该漏洞于今年1月获得修复。</p>
<p>360 Gear Team是360公司一支专注于云安全与互联网核心开源组件安全研究的新锐团队，2016年获QEMU、Xen、VirtualBox等虚拟化软件致谢65次，以及OpenSSL、NTP、Firefox等重要开源项目致谢49次，成立不到一年就荣获了上百次漏洞报告致谢。团队在保卫360自身内部业务安全的同时，也在守护互联网的安全。</p>
<p>时间线：</p>
<p>2017年1月17日正式在Oracle的Critical Patch Updates公布</p>
<p>2017年1月14日邮件通知预公布</p>
<p>2016年12月22日通知漏洞已修复</p>
<p>2016年12月3日Oracle回复确认邮件</p>
<p>2016年12月2日Qihoo 360Gear Team的 Li Qiang 将漏洞报告给Oracle安全团队<br />
具体描述：</p>
<p>在VirtualBox的文件src\VBox\Devices\Graphics\DevVGA-SVGA.cpp中SVGA设备模拟在处理FIFO命令SVGA_CMD_REMAP_GMR2的过程中存在堆溢出漏洞。<br /><a href="https://yqfile.alicdn.com/599f95773131ec82e14007ac41c0ffba6f94240e.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzU5OWY5NTc3MzEzMWVjODJlMTQwMDdhYzQxYzBmZmJhNmY5NDI0MGUucG5n.jpg"></a></p>
<p>左边是存在漏洞的文件，paNewPage64在堆上分配一块内存，大小由pGMR-&gt;cMaxPages指定，之后在一个循环中向该内存写入数据，通过pGMR-&gt;paDesc[i].numPages控制写入的数据。如果pGMR-&gt;cMaxPages比较小，但是pGMR-&gt;paDesc[i].numPages又比较大则会造成堆溢出。</p>
<p>进一步分析一下补丁。</p>
<p>首先看看pGMR-&gt;cMaxPages的限制。</p>
<p>pGMR-&gt;cMaxPages在修补之前可以由guest直接设置，只要长度大于VMSVGA_MAX_GMR_PAGES即可。在补丁之后，我们看到会有一个判断其是否小于pGMR-&gt;cbTotal/X86_PAGE_SIZE，这样就保证了pGMR-&gt;cMaxPages不会小于一定值。</p>
<p><a href="https://yqfile.alicdn.com/ccd4773da0ecacfb47de3ab82ace8af166456497.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2NjZDQ3NzNkYTBlY2FjZmI0N2RlM2FiODJhY2U4YWYxNjY0NTY0OTcucG5n.jpg"></a></p>
<p>继续看pGMR-&gt;paDesc[i].numPages的限制，在补丁之前，对该值是没有限制的，补丁只有也有一个最大的限制，即assertBreakStmt(desc.numPages &lt;= cMaxPages, rc = VERR_OUT_OF_RANGE)附近。</p>
<p><a href="https://yqfile.alicdn.com/64fd99a7e3b3a0e57c912aa65a15a331d18209c7.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzY0ZmQ5OWE3ZTNiM2EwZTU3YzkxMmFhNjVhMTVhMzMxZDE4MjA5YzcucG5n.jpg"></a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 22:10:34</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/oracle/" title="oracle">oracle</a>, <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%a0%96%e7%a4%be%e5%8c%ba/" title="云栖社区">云栖社区</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/%e5%ae%89%e5%85%a8/" title="安全">安全</a>, <a href="https://www.iamivan.net/tag/%e4%ba%91%e5%ae%89%e5%85%a8/" title="云安全">云安全</a>, <a href="https://www.iamivan.net/tag/image/" title="image">image</a>, <a href="https://www.iamivan.net/tag/%e4%b8%9a%e5%8a%a1%e5%ae%89%e5%85%a8/" title="业务安全">业务安全</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>甲骨文 VirtualBox高危堆溢出漏洞（CVE-2017-3332）剖析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRqEYp.html" rel="bookmark">Linux堆溢出漏洞利用之unlink</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux堆溢出漏洞利用之unlink 作者:走位@阿里聚安全 0 前言 1 背景介绍 首先,存在漏洞的程序如下: 在代码[3]中存在一个堆溢出漏洞:如果用户输入的argv[1]的大小比first变量的666字节更大的话,那么输入的数据就有可能覆盖掉下一个chunk的chunk header--这可以导致任意代码执行.而攻击的核心思路就是利用glibc malloc的unlink机制. 上述程序的内存图如下所示: 2 unlink技术原理 2.1 基本知识介绍 unlink攻击技术就是利用&quot;gl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7xx7qb.html" rel="bookmark">绿盟科技互联网安全威胁周报2016&period;31 Memcached多个整数溢出漏洞CVE-2016-8704</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				绿盟科技发布了本周安全通告,周报编号NSFOCUS-16-31,绿盟科技漏洞库本周新增31条,其中高危21条.本次周报建议大家关注持续关注Memcached多个整数溢出漏洞CVE-2016-8704.CVE-2016-8705.CVE-2016-8706,目前官方已发布修补后的最新版本,请广大用户检查自身Memcache版本,尽快升级. 焦点漏洞 Memcached多个整数溢出漏洞 CVE ID CVE-2016-8704 CVE-2016-8705 CVE-2016-8706 受影响版本 ve			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQPGYp.html" rel="bookmark">威胁预警通告 JavaScript引擎MuJS爆出堆栈溢出漏洞 请尽快升级最新版本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MuJS近日曝出多个堆溢出漏洞,绿盟科技给出的威胁预警级别为低级,这意味着影响较小,危害程度较小.修复方法请下载使用最新版本的MuJS: 1.使用git命令进行最新源码下载 &quot;git clone git://git.ghostscript.com/mujs.git&quot; 2.或到官网进行下载,链接如下https://github.com/ccxvii/mujs JavaScript引擎MuJS漏洞描述 Bug 697136 提交时间:2016年9月20日 POC及其详情见如下链接: htt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWAWdz.html" rel="bookmark">绿盟科技网络安全威胁周报2017&period;01 请关注MatrixSSL堆缓冲区溢出漏洞CVE-2016-6890</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				绿盟科技发布了本周安全通告,周报编号NSFOCUS-16-39,绿盟科技漏洞库本周新增30条,其中高危9条.本次周报建议大家关注 MatrixSSL 堆缓冲区溢出漏洞 ,目前,此漏洞已经公布了一段时间并且官方已经进行了修复,强烈建议仍在使用受影响版本的用户进行升级. 焦点漏洞 MatrixSSL 堆缓冲区溢出漏洞 NSFOCUS ID  35726 CVE ID  CVE-2016-6890 受影响版本 3.8.5 漏洞点评 MatrixSSL是SSL/TLS的开源实现,主要应用于嵌入式系统中.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwPg1p.html" rel="bookmark">绿盟科技网络安全威胁周报2017&period;28 关注Nginx远程整数溢出漏洞CVE-2017-7529</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				绿盟科技发布了本周安全通告,周报编号NSFOCUS-17-28,绿盟科技漏洞库本周新增74条,其中高危53条.本次周报建议大家关注 Nginx 远程整数溢出漏洞 .目前厂商已经发布了升级补丁以修复这个安全问题,请到 厂商主页 下载更新. 焦点漏洞 Nginx 远程整数溢出漏洞 NSFOCUS ID  37146 CVE ID  CVE-2017-7529 受影响版本 Nginx Nginx 0.5.6-1.13.2 漏洞点评 Nginx是一款使用非常广泛的高性能web服务器.Nginx 0.5.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrXPvmz.html" rel="bookmark">Skype爆严重缓冲区溢出漏洞，可提权于无形之中</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是Skype爆严重缓冲区溢出漏洞,可提权于无形之中,近日,微软旗下非常流行的免费网络短信和语音呼叫服务Skype被发现了一个严重的漏洞,该漏洞可以让黑客远程执行恶意代码或者导致系统崩溃.  Skype是一种免费的在线服务,允许用户之间通过互联网进行语音,视频和即时消息进行通信.由于其在全球具有很高的知名度,该服务于2011年5月被微软公司以85亿美元收购.  这枚未知的堆栈缓冲区溢出漏洞(CVE-2017-9948)位于Skype Web的消息和通话服务中,该漏洞是来自德国based s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmRk3Bz.html" rel="bookmark">PHP5&period;2下chunk&lowbar;split&lpar;&rpar;函数整数溢出漏洞 分析&lowbar;php文摘</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				受影响系统:PHP PHP &lt; 5.2.3不受影响系统:PHP PHP 5.2.3描述:--------------------------------------------------------------------------------BUGTRAQ ID: 24261CVE(CAN) ID: CVE-2007-2872 PHP是一种流行的WEB服务器端编程语言. PHP中的chunk_split函数在处理畸形参数时存在整数溢出漏洞,本地攻击者可能利用此漏洞提升自己的权限. PHP中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQJ6ap.html" rel="bookmark">无Sockets的远程溢出漏洞利用方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是无Sockets的远程溢出漏洞利用方法,在本文中,我将介绍一种在一个易受攻击的远程机器上获得shell访问的简单技术(这仅仅是我个人的观点).这不是我自己创造的技术,但我发现它很有趣.所以,本文的重点是这种技术本身,而不是利用漏洞的方式. 设置你的环境 所以,为了专注于制作远程shellcode,而不是如何规避ASLR,不可执行堆栈等(这将需要大量的篇幅进行介绍),我们将在测试中禁用大多数类似的功能.一旦你准备好了shellcode,便可以重新启用ASLR保护并尝试再次进行程序的漏洞利			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBgVQAM.html" rel="bookmark">Cisco Nexus 7000和7700交换机OTV缓冲区溢出漏洞 绿盟科技专家给出变通防护方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2016年10月5日,思科官网发布了存在于Cisco Nexus 7000系列和7700系列交换机中的OTV技术存在缓冲区溢出漏洞,此漏洞编号为CVE-2016-1453.该漏洞将导致攻击者执行任意代码,或者思科交换机的全部权限.官方已经给出升级补丁,如果您的交换机暂时无法升级,绿盟科技的专家给出了变通防护方案. 该漏洞位于Overlay Transport Virtualization(OTV)技术的GRE隧道协议实现中,由于对OTV包头部的参数没有进行完整校验,导致攻击者可以通过向受影响设备			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0XV7M.html" rel="bookmark" class="title">《Java极限编程》（Java Tool for Extreme Programming）读书笔记 （2）</a>
					<div>
						笔记|编程 第二章 J2EE部署其实这一章所讲的作为一个JAVA开发人员,尤其是J2EE开发人员,是几乎可以跳过的,因为这是基本常识,都应该懂.不过有点满有意思的: 原来只知道这样:&lt;apple ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOYo3M.html" rel="bookmark" class="title">卤猪病毒毁你没商量 可让用户系统崩溃</a>
					<div>
						本周有一个病毒特别凶险,就是&quot;卤猪(Win32.iuhzu.a)&quot;病毒.该病毒是能在Win 9x/NT/2000/XP系统上运行的病毒.该病毒运行后会将自身复制到硬盘各个分区的根目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0Em6p.html" rel="bookmark" class="title">韩国门户网站是如何将购物搜索结合的</a>
					<div>
						电子商务火爆的当下,很多网站都想从中分一杯羹.因此像网易和google这样的网站也把目标放在了购物搜索上,不过就目前来看国内的门户网站与电子商务的结合并没有倾尽全力的在做,很多都只是摆设或尝试,相比之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdmlaM.html" rel="bookmark" class="title">win7系统怎么添加日语输入法</a>
					<div>
						  win7系统怎么添加日语输入法            具体方法如下: 1.在我们的电脑的任务栏里有个[语言]的选项,我们据图操作.如果没有[语言]选项,我们可以在控制面板里面找到此项.然后单击[设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8aRab.html" rel="bookmark" class="title">诺顿磁盘医生怎么使用</a>
					<div>
						主界面: 进入主界面后,我们会看到以下选项: 1.Diagnose Disk ----即磁盘诊断,相对于磁盘表面检测来说可称之为一般诊断.可以检测到几乎所有的非物理性错误. 2.Surface Tes ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGAq1b.html" rel="bookmark" class="title">Win8系统下怎样正常播放exe格式课件</a>
					<div>
						如今很多人逐渐开始用上Windows 8系统,但使用中也发现了一些问题.很多用户表示在Win8系统中,exe格式的视频课件无法播放,因此造成很大的麻烦.这种情况该怎么解决呢? 解决方法 点击课件下载后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXonjp.html" rel="bookmark" class="title">win7旗舰版出现黑屏左上角光标闪烁如何解决</a>
					<div>
						  很多用户用u盘启动盘制作工具安装了系统,可是安装好之后在开机的时候却发现电脑出现了黑屏,而且同时在屏幕的左上角有一个光标在一直的闪烁,怎么都不能继续操作,这令很多用户都十分的头疼.那么win7旗舰 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkRK5b.html" rel="bookmark" class="title">如何使用Win7自带的截图工具</a>
					<div>
						  截图是我们经常进行的操作之一,很多童鞋都喜欢用QQ截图,一是方便,二是习惯,一上机就登陆QQ的人多得是.如果没联网,那该如何截图?我们可以用Win7自带的截图工具 ,用的习惯的话,绝对不比QQ截图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGP17b.html" rel="bookmark" class="title">将U盘打造成硬盘的方法</a>
					<div>
						  将U盘打造成硬盘的简单步骤: 1.在设备管理器中-----磁盘驱动器- 列表里有硬盘和你的U盘(SD卡),单击右键,更新驱动程序. 2.选择从列表或者指定位置安装,点击下一步,选择不要搜索,我要自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7Yq0M.html" rel="bookmark" class="title">cmd&period;exe文件损坏的解决办法</a>
					<div>
						  双击我的电脑,右击C盘选属性,工具,差错(开始检查),勾选自动修复文件系统错误,开始.会提示说无法修复,问你是否下次开机时修复,选是,下次重启不要动,自到启动完成.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq838Zb.html" rel="bookmark" class="title">Mac如何改变屏幕截图后文件保存的位置？</a>
					<div>
						  大家在如果经常访问MacGG,以前改看过苹果系统截图技巧这篇文章,但是不知道大家发现过这样的问题没,你所有的截图后的文件全部自动保存到桌面上了,那我们如何更改它保存的位置呢? 打开&quot;终端 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQQmnp.html" rel="bookmark" class="title">《ActionScript 3&period;0基础教程》&mdash;&mdash;导读</a>
					<div>
						前言 欢迎使用ActionScript,在接下来的几个章节里,你会了解到如何使用世界上最通用语言之一的ActionScript来创建网络应用程序.桌面应用程序以及面向多平台的移动应用程序.经过多年的发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6mrVb.html" rel="bookmark" class="title">oarcle mysql 字段的区别和互换</a>
					<div>
						mysql与oracle 表字段定义比较  有很多应用项目, 刚起步的时候用MYSQL数据库基本上能实现各种功能需求,随着应用用户的增多,数据量的增加,MYSQL渐渐地出现不堪重负的情况:连接很慢甚至 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NnNNM.html" rel="bookmark" class="title">vb无边框窗体-&lbrack;VB 6&period;0&rsqb;无边框窗体用&lbrack;JS&rsqb;实现左键&plus;拖动＝改变窗体大小</a>
					<div>
						问题描述 [VB 6.0]无边框窗体用[JS]实现左键+拖动＝改变窗体大小 设想:Form1(绝对的无边框,不是有边框去掉标题栏)中只有webbrowser一个控件,webbrowser与Form1大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj89ep.html" rel="bookmark" class="title">为什么用handler接收不到list对象</a>
					<div>
						问题描述 为什么用handler接收不到list对象 这是错误提示: at android.os.Handler.handleCallback(Handler.java:615) at android ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDdNGz.html" rel="bookmark" class="title">ATA接口寄存器描述</a>
					<div>
						ATA接口寄存器描述   3.ATA接口的三种数据传输方式   (1)PIO(Programmable Input-Output)传输,可以分为PIO寄存器传输和PIO数据传输.PIO寄存器传输主要用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAeY2p.html" rel="bookmark" class="title">教你如何利用算法原理，让TA对你一见钟情</a>
					<div>
						Tinder主打&quot;看脸配对&quot;,操作非常简单,如果对TA感兴趣,可以将照片向右滑动,代表喜欢:如果对TA不感兴趣,可以将照片向左滑动,让其消失.一旦双方都标记为了&quot;喜欢&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY8ZEp.html" rel="bookmark" class="title">亲们，loadrunner中录制飞机订票系统，怎么参数化航班？求详细介绍</a>
					<div>
						问题描述 亲们,loadrunner中录制飞机订票系统,怎么参数化航班?求详细介绍 Virtual User Script started at : 2015-09-30 10:25:58Starti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAx0ZM.html" rel="bookmark" class="title">百度回应360起诉：360要对投资病毒公司负责</a>
					<div>
						百度回应360起诉:360要对投资病毒公司负责11月18日消息,针对 360起诉百度炒作&quot;WireLurker&quot;病毒抹黑360一事,百度对媒体回应称,百度新闻坚持中立原则,用户可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bod8aXM.html" rel="bookmark" class="title">seo-请教&comma;asp&period;net如何实现百度sitemap实时推送</a>
					<div>
						问题描述 请教,asp.net如何实现百度sitemap实时推送 比如我后台发了一条咨询,能在发布后马上调用sitemap让百度收录新发布的页面内容 解决方案 百度什么时候收录,这个百度说了算,百度可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoGl9M.html" rel="bookmark" class="title">ssh添加</a>
					<div>
						问题描述 一,&lt;?xmlversion=&quot;1.0&quot;encoding=&quot;UTF-8&quot;?&gt;&lt;!DOCTYPEstruts-configPUBLIC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWq84z.html" rel="bookmark" class="title">js二级地域选择的实现方法&lowbar;javascript技巧</a>
					<div>
						实现二级地域的选择,前端大概有两种表现形式,第一,你是去放上两个文本框,点击文本框一的时候,出现省列表,点击文本框二的时候,出现该省的市区列表:第二种就是放两个下拉框了,在第一个下拉框选中一个,再到第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYN6qVp.html" rel="bookmark" class="title">一个带图片的考题，怎么写到WORD里面，谢谢</a>
					<div>
						问题描述 最近搞出题系统,遇到上面问题,咋搞呢,没思路啊 解决方案 解决方案二:读取到word里面去呀或者直接复制了呵呵解决方案三:不行吧,是保存在本地的文件解决方案四::用C#实现动态生成Word文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR12oab.html" rel="bookmark" class="title">Database &amp;&num;039&semi;xxxx&amp;&num;039&semi; is being recovered&period; Waiting until recovery is finished&period;</a>
					<div>
						巡检发现一个SQL SERVER Express 2005数据库备份时出现下面错误: Database 'xxxx' is being recovered. Waiting until recover ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenR4wb.html" rel="bookmark" class="title">poj  3258  River Hopscotch</a>
					<div>
						点击打开链接poj 3258 思路:二分 分析: 1 题目意思是有一条长度为L的河流,河里有n个石头,现在有奶牛从河的起点0,通过跳跃石头到达终点n+1:现在有一个人,想测掉m个石头,然后求两块石头之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Yn27p.html" rel="bookmark" class="title">Android--Activity在跳转时携带数据</a>
					<div>
						首先看看两种传递方法示例:(一个简单姻缘计算器) 主Activity [java] view plain copy  print? import android.os.Bundle;   import ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlA04np.html" rel="bookmark" class="title">由健康聪明风到3D立体风海尔空调引领行业舒适升级</a>
					<div>
						在空调市场同质化竞争日益激烈的当下,差异化的空调舒适使用体验成为产品受消费者青睐.企业在行业立足的重要筹码.而针对空调直吹送风导致的健康弊端,全球白电四连冠海尔率先改变了空调传统的送风方式,早在200 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAQQNvM.html" rel="bookmark" class="title">IEs 4 Linux访问微软IE浏览器的简便工具</a>
					<div>
						IEs 4 Linux 是在Linux(或者其他运行WINE的操作系统)中访问微软http://www.aliyun.com/zixun/aggregation/33885.html&quot;&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVXORlM.html" rel="bookmark" class="title">Convert&period;ToInt32&lpar;&rpar;转换老是出问题，求救？？？</a>
					<div>
						问题描述 有个DataGrid对象,第一列的我设定为&quot;超级链接列&quot;,对应的字段为CID,这个ID对应于MSSQL数据库的city表中的CID(数据类型为INT),然后我哦打算删除一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlWwnLb.html" rel="bookmark" class="title">中兴利比亚详情：首批员工枪声中将撤离</a>
					<div>
						2月22日消息,根据向中兴通讯的了解,正在利比亚的中兴通讯员工及家属总共有88人,在利比亚局势非常不稳定的情况下将分批回国,中兴通讯已经在当地组成了应急小组,并通过新浪科技向国内传回员工均安全的信息. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
